<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Assignment 3</title>
</head>
<body style="background-color: rgb(40, 40, 43); color: lightgray">
    <h1>Assignment 3</h1>
        <h3>Participants</h3>
            <ul>
                <li>Martin Mikkelsen</li>
                <li>Isar Buzza</li>
                <li>Sander Island</li>
            </ul>
        <h3>Desciption</h3>
            <p>This project is a group project for assignment 3 in Noroff's
                Java Fullstack course. In this project, we have created a database
                consisting of movies, characters and franchises, and our task is to
                extract and alter/update desired data.</p>
        <h3>Project task</h3>
            <p>You have been tasked with creating a datastore and interface to store and
                manipulate movie characters. It may be expanded over time to include
                other digital media, but for now, stick to movies.
                The application should be constructed in Spring Web and comprise of a
                database made in PostgreSQL through Hibernate with a RESTful API to allow
                users to manipulate the data. The database will store information about
                characters, movies they appear in, and the franchises these movies belong
                to. This should be able to be expanded on.

                Full CRUD is expected for Movies, Characters, and Franchises.
                You can do proper deletes, just ensure related data is not deleted –
                the foreign keys can be set to null (business logic).
                This means that Movies can have no Characters, and Franchises can
                have no Movies.

                When adding new resources, do not add related data at the same
                time (leave null), this is deferred to an update.
                The requirements for this are detailed below.</p>
        <h3>Endpoints</h3>
            <h4>Character endpoints</h4>
                <ul>
                    <li>GET:<br>characters/<br>characters/{id}</li>
                    <li>POST::<br>characters/</li>
                    <li>PUT:<br>characters/{id}/</li>
                    <li>DELETE:<br>characters/{id}</li>
                </ul>
            <h4>Movie endpoints</h4>
                <ul>
                    <li>GET:<br><a href="https://mcapi2503.herokuapp.com/movies" style="color: lightgray; font-family: arial;">movies/</a><br>movies/{id}<br>movies/{id}/characters</li>
                    <li>POST::<br>movies/</li>
                    <li>PUT:<br>movies/{id}/</li>
                    <li>DELETE:<br>movies/{id}</li>
                </ul>
            <h4>Franchise</h4>
                    <ul>
                        <li>GET:<br>franchises/<br>franchises/{id}<br>franchises/{id}/characters</li>
                        <li>POST::<br>franchises/</li>
                        <li>PUT:<br>franchises/{id}/</li>
                        <li>DELETE:<br>franchises/{id}</li>
                    </ul>
        <h3>Tools</h3>
            <ul>
                <li>IntelliJ har been used for coding</li>
                <li>pgAdmin has been used for handling the database</li>
                <li>Postgres SQL</li>
                <li>Postman for testing functionality</li>
                <li>Docker for container</li>
                <li>Heroku for deployment</li>
                <li>Swagger for API documentation</li>
            </ul>
        <h3>Git usage</h3>
            <p>We had our own branches where each group member worked
                on their given tasks.</p>
</body>
</html>